Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_bilapg.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_bilapg.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_bilapg.F90	(revision 3211)
@@ -30,4 +30,11 @@
 
    PUBLIC   tra_ldf_bilapg   ! routine called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
 
    !! * Substitutions
@@ -68,10 +75,18 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   wk1 => wrk_4d_1 , wk2 => wrk_4d_2     ! 4D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS wk1 wk2 :I :I :z :
       !
       INTEGER         , INTENT(in   )                      ::   kt       ! ocean time-step index
       CHARACTER(len=3), INTENT(in   )                      ::   cdtype   ! =TRA or TRC (tracer indicator)
       INTEGER         , INTENT(in   )                      ::   kjpt     ! number of tracers
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb      ! before and now tracer fields
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta      ! tracer trend 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb      ! before and now tracer fields
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta      ! tracer trend 
+!FTRANS ptb pta :I :I :z :
+      REAL(wp), INTENT(in   ) ::   ptb(jpi,jpj,jpk,kjpt)        ! before tracer fields
+      REAL(wp), INTENT(inout) ::   pta(jpi,jpj,jpk,kjpt)        ! tracer trend
+
       !
       INTEGER ::   ji, jj, jk, jn   ! dummy loop indices
@@ -105,7 +120,13 @@
       ! ---------------------------
       DO jn = 1, kjpt
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jj = 2, jpjm1
             DO jk = 1, jpkm1
                DO ji = 2, jpim1
+#endif
                   ! add it to the general tracer trends
                   pta(ji,jj,jk,jn) = pta(ji,jj,jk,jn) + wk2(ji,jj,jk,jn)
@@ -119,4 +140,10 @@
    END SUBROUTINE tra_ldf_bilapg
 
+!! * Reset control of array index permutation
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
 
    SUBROUTINE ldfght ( kt, cdtype, pt, plt, kjpt, kaht )
@@ -163,14 +190,27 @@
       USE wrk_nemo, ONLY:   zftw => wrk_xz_1 , zdit  => wrk_xz_2 
       USE wrk_nemo, ONLY:   zdjt => wrk_xz_3 , zdj1t => wrk_xz_4
-      !
-      INTEGER         , INTENT(in )                              ::  kt      ! ocean time-step index
-      CHARACTER(len=3), INTENT(in )                              ::  cdtype  ! =TRA or TRC (tracer indicator) 
-      INTEGER         , INTENT(in )                              ::  kjpt    !: dimension of 
-      REAL(wp)        , INTENT(in ), DIMENSION(jpi,jpj,jpk,kjpt) ::  pt      ! tracer fields ( before for 1st call
-      !                                                         ! and laplacian of these fields for 2nd call. 
-      REAL(wp)        , INTENT(out), DIMENSION(jpi,jpj,jpk,kjpt) ::  plt     !: partial harmonic operator applied to  pt  components except
-      !                                                             !: second order vertical derivative term  
-      INTEGER         , INTENT(in )                              ::  kaht    !: =1 multiply the laplacian by the eddy diffusivity coeff.
-      !                                                             !: =2 no multiplication 
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zftv :I :I :z
+
+      !
+      INTEGER, INTENT(in )                               ::  kt      ! ocean time-step index
+      CHARACTER(len=3), INTENT(in )                      ::  cdtype  ! =TRA or TRC (tracer indicator) 
+      INTEGER, INTENT(in )                               ::  kjpt    !: dimension of 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), INTENT(in ), DIMENSION(jpi,jpj,jpk,kjpt) ::  pt      ! tracer fields ( before for 1st call
+!     !                                                         ! and laplacian of these fields for 2nd call. 
+!     REAL(wp), INTENT(out), DIMENSION(jpi,jpj,jpk,kjpt) ::  plt     !: partial harmonic operator applied to  pt components except
+!     !                                                              !: second order vertical derivative term  
+
+!FTRANS pt plt :I :I :z :
+      REAL(wp), INTENT(in )  ::  pt(jpi,jpj,jpk,kjpt)      ! tracer fields ( before for 1st call
+      !                                                    ! and laplacian of these fields for 2nd call. 
+      REAL(wp), INTENT(out)  ::  plt(jpi,jpj,jpk,kjpt)     !: partial harmonic operator applied to  pt components except
+      !                                                    !: second order vertical derivative term  
+
+      INTEGER, INTENT(in )                               ::  kaht    !: =1 multiply the laplacian by the eddy diffusivity coeff.
+      !                                                              !: =2 no multiplication 
       !!
       INTEGER ::   ji, jj, jk,jn          ! dummy loop indices
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso.F90	(revision 3211)
@@ -38,4 +38,12 @@
    PUBLIC   tra_ldf_iso   ! routine called by step.F90
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -92,6 +100,16 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE oce     , ONLY:   zftu => ua       , zftv  => va         ! (ua,va) used as workspace
-      USE wrk_nemo, ONLY:   zdkt => wrk_2d_1 , zdk1t => wrk_2d_2 , z2d  => wrk_2d_3   ! 2D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zftu zftv :I :I :z
+#if defined key_z_first
+      USE wrk_nemo, ONLY:   wdkt => wrk_3d_9 , wdk1t => wrk_3d_10  ! 3D workspace
+!FTRANS wdkt wdk1t :I :I :z
+#else
+      USE wrk_nemo, ONLY:   zdkt => wrk_2d_1 , zdk1t => wrk_2d_2
+#endif
+      USE wrk_nemo, ONLY:   z2d  => wrk_2d_3                       ! 2D workspace
       USE wrk_nemo, ONLY:   zdit => wrk_3d_6 , zdjt  => wrk_3d_7 , ztfw => wrk_3d_8   ! 3D workspace
+!FTRANS zdit zdjt ztfw :I :I :z
+
       !
       INTEGER                              , INTENT(in   ) ::   kt         ! ocean time-step index
@@ -99,6 +117,12 @@
       INTEGER                              , INTENT(in   ) ::   kjpt       ! number of tracers
       REAL(wp), DIMENSION(jpi,jpj    ,kjpt), INTENT(in   ) ::   pgu, pgv   ! tracer gradient at pstep levels
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb        ! before and now tracer fields
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta        ! tracer trend 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb        ! before and now tracer fields
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta        ! tracer trend 
+!FTRANS ptb pta :I :I :z :
+      REAL(wp), INTENT(in   ) ::   ptb(jpi,jpj,jpk,kjpt)        ! before and now tracer fields
+      REAL(wp), INTENT(inout) ::   pta(jpi,jpj,jpk,kjpt)        ! tracer trend 
+
       REAL(wp)                             , INTENT(in   ) ::   pahtb0     ! background diffusion coef
       !
@@ -112,5 +136,9 @@
       !!----------------------------------------------------------------------
 
+#if defined key_z_first
+      IF( wrk_in_use(3, 6,7,8,9,10) .OR. wrk_in_use(2, 3) ) THEN
+#else
       IF( wrk_in_use(3, 6,7,8) .OR. wrk_in_use(2, 1,2,3) ) THEN
+#endif
           CALL ctl_stop('tra_ldf_iso : requested workspace array unavailable')   ;   RETURN
       ENDIF
@@ -135,7 +163,13 @@
 
          ! Horizontal tracer gradient 
+#if defined key_z_first
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpjm1
                DO ji = 1, fs_jpim1   ! vector opt.
+#endif
                   zdit(ji,jj,jk) = ( ptb(ji+1,jj  ,jk,jn) - ptb(ji,jj,jk,jn) ) * umask(ji,jj,jk)
                   zdjt(ji,jj,jk) = ( ptb(ji  ,jj+1,jk,jn) - ptb(ji,jj,jk,jn) ) * vmask(ji,jj,jk)
@@ -155,4 +189,56 @@
          !!   II - horizontal trend  (full)
          !!----------------------------------------------------------------------
+#if defined key_z_first
+            ! 1. Vertical tracer gradient at level jk and jk+1
+            ! ------------------------------------------------
+            ! surface boundary condition: wdkt(jk=1)=wdkt(jk=2)
+
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  wdk1t(ji,jj,jk) = ( ptb(ji,jj,jk,jn) - ptb(ji,jj,jk+1,jn) ) * tmask(ji,jj,jk+1)
+               END DO
+               wdkt(ji,jj,1) = wdk1t(ji,jj,1)
+               DO jk = 2, jpkm1
+                  wdkt(ji,jj,jk) =  ( ptb(ji,jj,jk-1,jn) - ptb(ji,jj,jk,jn) ) * tmask(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+
+            ! 2. Horizontal fluxes
+            ! --------------------   
+         DO jj = 1 , jpjm1
+            DO ji = 1, jpim1
+               DO jk = 1, jpkm1
+                  zabe1 = ( fsahtu(ji,jj,jk) + pahtb0 ) * e2u(ji,jj) * fse3u(ji,jj,jk) / e1u(ji,jj)
+                  zabe2 = ( fsahtv(ji,jj,jk) + pahtb0 ) * e1v(ji,jj) * fse3v(ji,jj,jk) / e2v(ji,jj)
+                  zmsku = 1. / MAX(  tmask(ji+1,jj,jk  ) + tmask(ji,jj,jk+1)   &
+                     &             + tmask(ji+1,jj,jk+1) + tmask(ji,jj,jk  ), 1. )
+                  zmskv = 1. / MAX(  tmask(ji,jj+1,jk  ) + tmask(ji,jj,jk+1)   &
+                     &             + tmask(ji,jj+1,jk+1) + tmask(ji,jj,jk  ), 1. )
+                  zcof1 = - fsahtu(ji,jj,jk) * e2u(ji,jj) * uslp(ji,jj,jk) * zmsku
+                  zcof2 = - fsahtv(ji,jj,jk) * e1v(ji,jj) * vslp(ji,jj,jk) * zmskv
+                  zftu(ji,jj,jk ) = ( zabe1 * zdit(ji,jj,jk)   &
+                     &              + zcof1 * (  wdkt (ji+1,jj,jk) + wdk1t(ji,jj,jk)      &
+                     &                         + wdk1t(ji+1,jj,jk) + wdkt (ji,jj,jk)  )  ) * umask(ji,jj,jk)
+                  zftv(ji,jj,jk) = (  zabe2 * zdjt(ji,jj,jk)   &
+                     &              + zcof2 * (  wdkt (ji,jj+1,jk) + wdk1t(ji,jj,jk)      &
+                     &                         + wdk1t(ji,jj+1,jk) + wdkt (ji,jj,jk)  )  ) * vmask(ji,jj,jk)                  
+               END DO
+            END DO
+         END DO
+
+            ! II.4 Second derivative (divergence) and add to the general trend
+            ! ----------------------------------------------------------------
+         DO jj = 2 , jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+                  zbtr = 1.0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  ztra = zbtr * ( zftu(ji,jj,jk) - zftu(ji-1,jj,jk) + zftv(ji,jj,jk) - zftv(ji,jj-1,jk)  )
+                  pta(ji,jj,jk,jn) = pta(ji,jj,jk,jn) + ztra
+               END DO
+            END DO
+         END DO
+#else
 !CDIR PARALLEL DO PRIVATE( zdk1t ) 
          !                                                ! ===============
@@ -205,4 +291,5 @@
          END DO                                        !   End of slab  
          !                                             ! ===============
+#endif
          !
          ! "Poleward" diffusive heat or salt transports (T-S case only)
@@ -216,7 +303,13 @@
             z2d(:,:) = 0._wp 
             zztmp = rau0 * rcp 
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      z2d(ji,jj) = z2d(ji,jj) + zftu(ji,jj,jk) 
                   END DO
@@ -227,7 +320,13 @@
             CALL iom_put( "udiff_heattr", z2d )                  ! heat transport in i-direction
             z2d(:,:) = 0._wp 
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      z2d(ji,jj) = z2d(ji,jj) + zftv(ji,jj,jk) 
                   END DO
@@ -255,7 +354,13 @@
          
          ! interior (2=<jk=<jpk-1)
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zcoef0 = - fsahtw(ji,jj,jk) * tmask(ji,jj,jk)
                   !
@@ -279,7 +384,13 @@
          ! I.5 Divergence of vertical fluxes added to the general tracer trend
          ! -------------------------------------------------------------------
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zbtr = 1.0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
                   ztra = (  ztfw(ji,jj,jk) - ztfw(ji,jj,jk+1)  ) * zbtr
@@ -291,6 +402,11 @@
       END DO
       !
+#if defined key_z_first
+      IF( wrk_not_released(3, 6,7,8,9,10) .OR.   &
+          wrk_not_released(2, 3) )       CALL ctl_stop('tra_ldf_iso: failed to release workspace arrays')
+#else
       IF( wrk_not_released(3, 6,7,8) .OR.   &
           wrk_not_released(2, 1,2,3) )   CALL ctl_stop('tra_ldf_iso: failed to release workspace arrays')
+#endif
       !
    END SUBROUTINE tra_ldf_iso
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90	(revision 3211)
@@ -36,4 +36,13 @@
    REAL(wp),         DIMENSION(:,:,:), ALLOCATABLE, SAVE ::   zdkt                 !  atypic workspace
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+#  include "traldf_iso_grif_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -93,4 +102,9 @@
       USE wrk_nemo, ONLY:   zdit => wrk_3d_6 , zdjt => wrk_3d_7 , ztfw => wrk_3d_8   ! 3D workspace
       USE wrk_nemo, ONLY:   z2d  => wrk_2d_1                                         ! 2D workspace
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zftu zftv :I :I :z
+!FTRANS zdit zdjt ztfw :I :I :z
+
       !
       INTEGER                              , INTENT(in   ) ::   kt         ! ocean time-step index
@@ -98,6 +112,13 @@
       INTEGER                              , INTENT(in   ) ::   kjpt       ! number of tracers
       REAL(wp), DIMENSION(jpi,jpj    ,kjpt), INTENT(in   ) ::   pgu, pgv   ! tracer gradient at pstep levels
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb        ! before and now tracer fields
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta        ! tracer trend 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb        ! before and now tracer fields
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta        ! tracer trend 
+
+!FTRANS ptb pta :I :I :z :
+      REAL(wp), INTENT(in   ) ::   ptb(jpi,jpj,jpk,kjpt)        ! before and now tracer fields
+      REAL(wp), INTENT(inout) ::   pta(jpi,jpj,jpk,kjpt)        ! tracer trend 
+
       REAL(wp)                             , INTENT(in   ) ::   pahtb0     ! background diffusion coef
       !
@@ -156,7 +177,13 @@
       DO ip = 0, 1
          DO kp = 0, 1
+#if defined key_z_first
+            DO jj = 1, jpjm1
+               DO ji = 1, jpim1
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 1, jpjm1
                   DO ji = 1, fs_jpim1
+#endif
                      ze3wr = 1._wp / fse3w(ji+ip,jj,jk+kp)
                      zbu   = 0.25_wp * e1u(ji,jj) * e2u(ji,jj) * fse3u(ji,jj,jk)
@@ -179,7 +206,13 @@
       DO jp = 0, 1
          DO kp = 0, 1
+#if defined key_z_first
+            DO jj = 1, jpjm1
+               DO ji=1, jpim1
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 1, jpjm1
                   DO ji=1,fs_jpim1
+#endif
                      ze3wr = 1.0_wp / fse3w(ji,jj+jp,jk+kp)
                      zbv   = 0.25_wp * e1v(ji,jj) * e2v(ji,jj) * fse3v(ji,jj,jk)
@@ -208,7 +241,14 @@
          zftv(:,:,:) = 0._wp
          !                                               
+#if defined key_z_first
+         !==  before lateral T & S gradients at T-level jk  ==!
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1                          !==  before lateral T & S gradients at T-level jk  ==!
             DO jj = 1, jpjm1
                DO ji = 1, fs_jpim1   ! vector opt.
+#endif
                   zdit(ji,jj,jk) = ( ptb(ji+1,jj  ,jk,jn) - ptb(ji,jj,jk,jn) ) * umask(ji,jj,jk)
                   zdjt(ji,jj,jk) = ( ptb(ji  ,jj+1,jk,jn) - ptb(ji,jj,jk,jn) ) * vmask(ji,jj,jk)
@@ -303,7 +343,13 @@
          END DO
          !
+#if defined key_z_first
+         DO jj = 2, jpjm1            !== Divergence of vertical fluxes added to the general tracer trend
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1            !== Divergence of vertical fluxes added to the general tracer trend
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   pta(ji,jj,jk,jn) = pta(ji,jj,jk,jn) + (  ztfw(ji,jj,jk+1) - ztfw(ji,jj,jk)  )   &
                      &                                / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
@@ -322,7 +368,13 @@
             z2d(:,:) = 0._wp 
             zztmp = rau0 * rcp 
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      z2d(ji,jj) = z2d(ji,jj) + zftu(ji,jj,jk) 
                   END DO
@@ -333,7 +385,13 @@
             CALL iom_put( "udiff_heattr", z2d )                  ! heat transport in i-direction
             z2d(:,:) = 0._wp 
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
+                  DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      z2d(ji,jj) = z2d(ji,jj) + zftv(ji,jj,jk) 
                   END DO
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif_ftrans.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif_ftrans.h90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif_ftrans.h90	(revision 3211)
@@ -0,0 +1,23 @@
+   !!----------------------------------------------------------------------
+   !!                   ***  traldf_iso_grif_ftrans  ***
+   !!----------------------------------------------------------------------
+   !! ** purpose : Directives to control permutation of array indices for
+   !!   public multi-dimensional arrays with a z-dimension declared in
+   !!   module traldf_iso_grif_ftrans.  It should be included wherever the
+   !!   module is used, and updated whenever a new public array is added
+   !!   to the module.
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+#if defined key_z_first
+!FTRANS assert :z :I
+#else
+!FTRANS assert :I :z
+#endif
+!FTRANS psix_eiv :I :I :z
+!FTRANS psiy_eiv :I :I :z
+!FTRANS ah_wslp2 :I :I :z
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_lap.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_lap.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_lap.F90	(revision 3211)
@@ -33,4 +33,10 @@
    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:) ::   e1ur, e2vr   ! scale factor coefficients
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -64,4 +70,8 @@
       !!----------------------------------------------------------------------
       USE oce, ONLY:   ztu => ua , ztv => va  ! (ua,va) used as workspace
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS ztu ztv :I :I :z
+
       !
       INTEGER                              , INTENT(in   ) ::   kt         ! ocean time-step index
@@ -69,6 +79,12 @@
       INTEGER                              , INTENT(in   ) ::   kjpt       ! number of tracers
       REAL(wp), DIMENSION(jpi,jpj    ,kjpt), INTENT(in   ) ::   pgu, pgv   ! tracer gradient at pstep levels
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb        ! before and now tracer fields
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta        ! tracer trend 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb        ! before and now tracer fields
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta        ! tracer trend 
+
+!FTRANS ptb pta :I :I :z :
+      REAL(wp), INTENT(in   ) ::   ptb(jpi,jpj,jpk,kjpt)        ! before and now tracer fields
+      REAL(wp), INTENT(inout) ::   pta(jpi,jpj,jpk,kjpt)        ! tracer trend 
       !
       INTEGER  ::   ji, jj, jk, jn       ! dummy loop indices
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/tranpc.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/tranpc.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/tranpc.F90	(revision 3211)
@@ -29,4 +29,9 @@
    PUBLIC   tra_npc       ! routine called by step.F90
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -59,4 +64,8 @@
       USE wrk_nemo, ONLY:   ztrdt => wrk_3d_1 , ztrds => wrk_3d_2 , zrhop => wrk_3d_3
       USE wrk_nemo, ONLY:   zwx   => wrk_xz_1 , zwy   => wrk_xz_2 , zwz   => wrk_xz_3
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS ztrdt ztrds zrhop :I :I :z
+
       !
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
@@ -93,6 +102,11 @@
             !  Static instability pointer 
             ! ----------------------------
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   zwx(ji,jk) = ( zrhop(ji,jj,jk) - zrhop(ji,jj,jk+1) ) * tmask(ji,jj,jk+1)
                END DO
